/* chunk_8svx_body.hh
 * Copyright (C) 2020 Ralf Hoffmann.
 * ralf@boomerangsworld.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CHUNK_8SVX_BODY_HH
#define CHUNK_8SVX_BODY_HH

#include "chunk_generic.hh"

class ChunkVHDR;

class Chunk8SVXBODY : public ChunkGeneric {
public:
    json_t *dump_as_json( const shared_properties_t &shared_props,
                          bool include_raw ) const override;
    int decode( const std::shared_ptr< ChunkVHDR > &vhdr,
                std::vector< std::vector< int8_t > > &all_samples ) const;
protected:
    int parse_chunk( const std::vector< char > &data ) override;

    int decompressFDE( std::vector< int8_t > &result,
                       const std::vector< int8_t > &input ) const;
};

#endif /* CHUNK_8SVX_BODY_HH */
