/* chunk_cmap.hh
 * Copyright (C) 2020 Ralf Hoffmann.
 * ralf@boomerangsworld.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CHUNK_CMAP_HH
#define CHUNK_CMAP_HH

#include "chunk_generic.hh"

class ChunkCMAP : public ChunkGeneric {
public:
    json_t *dump_as_json( const shared_properties_t &shared_props,
                          bool include_raw ) const override;

    class cmap_raw_color {
    public:
        cmap_raw_color()
        {}

        cmap_raw_color( uint8_t r, uint8_t g, uint8_t b ) :
            red( r ),
            green( g ),
            blue( b )
        {}
        uint8_t red = 0;
        uint8_t green = 0;
        uint8_t blue = 0;
    };

    cmap_raw_color get_color( uint8_t palette_entry ) const;
    size_t colors() const;
protected:
    int parse_chunk( const std::vector< char > &data ) override;
private:
    std::vector< cmap_raw_color > m_colors;
};

#endif /* CHUNK_CMAP_HH */
