/* chunk_crng.hh
 * Copyright (C) 2020 Ralf Hoffmann.
 * ralf@boomerangsworld.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CHUNK_CRNG_HH
#define CHUNK_CRNG_HH

#include "chunk_generic.hh"

class ChunkCRNG : public ChunkGeneric {
public:
    json_t *dump_as_json( const shared_properties_t &shared_props,
                          bool include_raw ) const override;

    static const uint16_t CRNG_FLAG_ACTIVE = 1;
    static const uint16_t CRNG_FLAG_REVERSE = 2;
protected:
    int parse_chunk( const std::vector< char > &data ) override;
private:
    uint16_t m_cycle_rate;
    uint16_t m_flags;
    uint8_t m_low_color;
    uint8_t m_high_color;
};

#endif /* CHUNK_CRNG_HH */
