/* chunk_dlta.hh
 * Copyright (C) 2020 Ralf Hoffmann.
 * ralf@boomerangsworld.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CHUNK_DLTA_HH
#define CHUNK_DLTA_HH

#include "chunk_generic.hh"

class ChunkBMHD;
class ChunkANHD;

class ChunkDLTA : public ChunkGeneric {
public:
    json_t *dump_as_json( const shared_properties_t &shared_props,
                          bool include_raw ) const override;

    int apply_delta( const std::shared_ptr< ChunkBMHD > &bmhd,
                     const std::shared_ptr< ChunkANHD > &anhd,
                     const std::vector< std::vector< uint8_t > > &planes,
                     std::vector< std::vector< uint8_t > > &res ) const;
protected:
    int parse_chunk( const std::vector< char > &data ) override;
private:
    int apply_delta5( const std::shared_ptr< ChunkBMHD > &bmhd,
                      const std::shared_ptr< ChunkANHD > &anhd,
                      const std::vector< std::vector< uint8_t > > &planes,
                      std::vector< std::vector< uint8_t > > &res ) const;
    int apply_delta7( const std::shared_ptr< ChunkBMHD > &bmhd,
                      const std::shared_ptr< ChunkANHD > &anhd,
                      const std::vector< std::vector< uint8_t > > &planes,
                      std::vector< std::vector< uint8_t > > &res ) const;
    int apply_delta8( const std::shared_ptr< ChunkBMHD > &bmhd,
                      const std::shared_ptr< ChunkANHD > &anhd,
                      const std::vector< std::vector< uint8_t > > &planes,
                      std::vector< std::vector< uint8_t > > &res ) const;
    int apply_delta23( const std::shared_ptr< ChunkBMHD > &bmhd,
                       const std::shared_ptr< ChunkANHD > &anhd,
                       const std::vector< std::vector< uint8_t > > &planes,
                       std::vector< std::vector< uint8_t > > &res,
                       bool long_data ) const;
    int apply_delta4( const std::shared_ptr< ChunkBMHD > &bmhd,
                      const std::shared_ptr< ChunkANHD > &anhd,
                      const std::vector< std::vector< uint8_t > > &planes,
                      std::vector< std::vector< uint8_t > > &res ) const;
};

#endif /* CHUNK_DLTA_HH */
