/* chunk_fhdr.hh
 * Copyright (C) 2020 Ralf Hoffmann.
 * ralf@boomerangsworld.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CHUNK_FHDR_HH
#define CHUNK_FHDR_HH

#include "chunk_generic.hh"
#include "chunk_cmap.hh"

class ChunkFHDR : public ChunkGeneric {
public:
    json_t *dump_as_json( const shared_properties_t &shared_props,
                          bool include_raw ) const override;
    int fill_info( IFFInfo &info ) const override;

    uint16_t width() const;
    uint16_t height() const;
    uint16_t depth() const;

    std::shared_ptr< ChunkCMAP > get_cmap() const;
protected:
    int parse_chunk( const std::vector< char > &data ) override;
private:
    uint16_t m_width = 0, m_height = 0;
    uint16_t m_depth = 0;
    std::vector< ChunkCMAP::cmap_raw_color > m_palette;
};

#endif /* CHUNK_FHDR_HH */
