/* chunk_fons.hh
 * Copyright (C) 2020 Ralf Hoffmann.
 * ralf@boomerangsworld.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CHUNK_FONS_HH
#define CHUNK_FONS_HH

#include "chunk_generic.hh"

class ChunkFONS : public ChunkGeneric {
public:
    json_t *dump_as_json( const shared_properties_t &shared_props,
                          bool include_raw ) const override;

    static const uint8_t PROPORTIONAL_UNKNOWN = 0;
    static const uint8_t PROPORTIONAL_NO = 1;
    static const uint8_t PROPORTIONAL_YES = 2;

    static const uint8_t SERIF_UNKNOWN = 0;
    static const uint8_t SERIF_NO = 1;
    static const uint8_t SERIF_YES = 2;
protected:
    int parse_chunk( const std::vector< char > &data ) override;
private:
    uint8_t m_font_id;
    uint8_t m_proportional;
    uint8_t m_serif;
    std::string m_font_name;
};

#endif /* CHUNK_FONS_HH */
