/* chunk_ssa_form.hh
 * Copyright (C) 2020 Ralf Hoffmann.
 * ralf@boomerangsworld.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CHUNK_SSAFORM_HH
#define CHUNK_SSAFORM_HH

#include "chunk_generic.hh"

class ChunkSSAFORM : public ChunkGeneric {
public:
    std::string dump_as_readable_text( const shared_properties_t &shared_props ) override;
    json_t *dump_as_json( const shared_properties_t &shared_props,
                          bool include_raw ) const override;
    int dump_as_binary( const shared_properties_t &shared_props,
                        std::list< IFFBinaryResult > &output,
                        bool include_raw ) const;
protected:
    int parse_chunk( const std::vector< char > &data ) override;
    int read_into_raw( const char *buf,
                       size_t buflen,
                       size_t &raw_chunklen ) override;
private:
    uint32_t m_ssaform_type = 0;
    std::list< std::shared_ptr< ChunkGeneric > > m_chunks;

    int m_ssa_variant = 0;
};

#endif /* CHUNK_SSAFORM_HH */
